
'-----------------------------------------------------------------------
' Glyphix - main controller
' with a PIC18F4680
'
' Written by Wauters Kris - january, 12th - 2007
'-----------------------------------------------------------------------
											 
'-----------------------------------------------------------------------
'--- PIC related                                                     ---
'-----------------------------------------------------------------------

OPTIMISER_LEVEL = 0

Device = 18F4680 			    'use the 18F4680 PIC
XTAL = 20						'at 20 Mhz
ALL_DIGITAL = true				'all pins ar digital

'-----------------------------------------------------------------------
'--- MMC/SD related                                                  ---
'-----------------------------------------------------------------------
Symbol SD_CS  = PORTA.0
Symbol SD_DI  = PORTA.1
Symbol SD_CLK = PORTA.3
Symbol SD_DO  = PORTA.2	
Include "18F4680_main_Lib.pbp"
'Enable Debug

'--- matrix control ---
Output PORTC.5      'data in
Output PORTC.6      'data load
Output PORTC.4      'data clk
Symbol DataIn   = PORTC.5
Symbol DataLoad = PORTC.6
Symbol DataClk  = PORTC.4

Dim IdNr As Byte
Dim Value[129] As Byte
Dim a As Byte
Dim c As Byte
Dim WriteLoop As Byte
Dim ticker As Word

'-----------------------------------------------------------------------
'--- general variables                                               ---
'-----------------------------------------------------------------------
Dim BitExternal As Bit
Dim BitScheduler As Bit
Dim BitUSB As Bit
Dim X As Byte
Dim Y As Byte
Dim Z As String * 1
Dim AX As Word
Dim AY As Word

'-----------------------------------------------------------------------
'--- sending and receiving data across both PIC's                    ---
'-----------------------------------------------------------------------
Dim Dout As string*17
Dim Din  As string*17
Dim xxx As Byte
Dim yyy As Byte
Dim zzz As Byte
Dim Response As Byte
Dim SelectExt As string*3
Dim NbrChars As Byte
Dim ScheduleDateTime As string*10
Dim CompareDateTime As string*10
Dim ScheduleDEC As DWord
Dim CompareDEC As DWord
Dim ItemData As string*13
Dim SchPos As Byte
Dim SchCount As Byte
Dim BitOK As Bit
Dim RequestType As Byte

Output PORTC.0
Output PORTC.1
Low PORTC.0
Low PORTC.1
Input  PORTD.0
Input  PORTD.1

Symbol DOutPin = PORTC.0
Symbol DOutClk = PORTC.1
Symbol DInPin  = PORTD.0
Symbol DInClk  = PORTD.1

'-----------------------------------------------------------------------
'--- definitions                                                     ---
'-----------------------------------------------------------------------
'--- controle LEDs ---
Output PORTA.5  ' LED RED
Output PORTE.0  ' LED YELLOW
Output PORTE.1  ' LED GREEN
Symbol LedRed = PORTA.5
Symbol LedYellow = PORTE.0
Symbol LedGreen = PORTE.1

'--- led backlight ---
Output PORTD.2      'LCD backlight
Symbol LCDBackLight = PORTD.2

'-------------------------------------------------------------------------------
'--- startup                                                                 ---
'-------------------------------------------------------------------------------
DelayMS 100

Repeat
    High LedRed
    DelayMS 250
    Response = SD_Init_FS
    Low LedRed
    DelayMS 250
Until Response = 0

'--- initialise LED matrix ---
IdNr=$0C:Value[1]=$01:GoSub SetNext127:GoSub WriteData:        '--- init             ---
IdNr=$09:Value[1]=$00:GoSub SetNext127:GoSub WriteData:        '--- init decode mode ---
IdNr=$0B:Value[1]=$07:GoSub SetNext127:GoSub WriteData:        '--- init scanlimit   ---
GoSub SetMatrixBrightNess:
IdNr=$0F:Value[1]=$01:GoSub SetNext127:GoSub WriteData:        '--- init testmode    ---
DelayMS 500
IdNr=$0F:Value[1]=$00:GoSub SetNext127:GoSub WriteData:        '--- init do-it-mode  ---
DelayMS 500

'--- clear LED matrix ---
a=0:
Repeat
    Inc a
    Value[a] = 0
Until a = 8
a=0:
Repeat
    Inc a
    IdNr = a:GoSub WriteData
Until a = 8
DelayMS 200


TestLoop:
    If LedGreen = 0 Then
        Low LedGreen
    Else
        High LedGreen
    EndIf
    GoSub DoAnimation:
GoTo TestLoop:

'-------------------------------------------------------------------------------
'--- main application                                                        ---
'-------------------------------------------------------------------------------

Hoofdlus:
    If DInPin = 1 Then
        GoSub ReceiveData
        Select Case Din[0]
            Case "B"
                '--- backlight ---
                If Din[1]="A" Then High LCDBackLight
                If Din[1]="U" Then Low LCDBackLight
            Case "A"
                SelectExt= "ANI"
                Select Case Din[1]
                    Case "L"    '---list items                   ---
                        GoSub ReturnFileNames            
                    Case "S"    '---item is selected             ---
                        GoSub PositionToFile
                    
                    Case "I"    '---info wanted about given item ---
                        GoSub PositionToFile
                        GoSub ReturnFileInfo
                        
                End Select
            Case "P"
                '--- playlists ---
                SelectExt= "LST"
                Select Case Din[1]
                    Case "L"    '---list items                   ---
                        GoSub ReturnFileNames            
                    Case "S"    '---item is selected             ---
                        GoSub PositionToFile
                    
                    Case "I"    '---info wanted about given item ---
                        GoSub PositionToFile
                        GoSub ReturnFileInfo

                End Select
            Case "T"    '--- notification that scheduled item needs to be started ! ---
                RequestType = 4
                SchPos = 0
                'GoSub ReturnScheduledItems
            Case "C"
                '--- Scheduler --- 'different from the rest, openup SCH file, and read data from it ---
                SelectExt= "SCH"
                Select Case Din[1]
                    Case "L"    '---list items                   ---
                        If Din[2] = 0 Then
                            SchPos = 0
                        Else
                            SchPos = (Din[2])*5)-1
                        EndIf
                        RequestType = 1
                        GoSub ReturnScheduledItems
                        
                    Case "I"    '---info wanted about given item ---
                        SchPos = (Din[2]*5)
                        SchPos = SchPos + Din[3] - 1
                        RequestType = 2
                        GoSub ReturnScheduledItems   
                    Case "W"
                        SchPos = 0
                        RequestType = 3
                        GoSub ReturnScheduledItems                                         
                End Select
            
            Case "S"
                '--- sCheduler ---
                If Din[1]="A" Then 
                    BitScheduler = 1
                    High LedRed
                EndIf
                If Din[1]="U" Then 
                    BitScheduler = 0
                    Low LedRed
                EndIf
            Case "E"
                '--- external control ---
                If Din[1]="A" Then 
                    BitExternal = 1
                    High LedGreen
                EndIf
                If Din[1]="U" Then 
                    BitExternal = 0
                    Low LedGreen
                EndIf
            Case "U"
                '--- USB ---
                If Din[1]="A" Then 
                    BitUSB = 1
                    Low LedRed:High LedYellow:Low LedGreen
                EndIf
                If Din[1]="U" Then
                    BitUSB = 0
                    Low LedYellow
                EndIf    
        End Select
    EndIf
GoTo Hoofdlus:

'-----------------------------------------------------------------------
'--- Returns the scheduled items in the SCH-file,                    ---
'--- only with date/time that is not yet passed ...                  ---
'--- scheduled items are ordered in the file, by the client-app on PC---
'-----------------------------------------------------------------------         
ReturnScheduledItems:
    ScheduleDateTime = Str$(HEX2 Din[10]) + Str$(HEX2 Din[11]) + Str$(HEX2 Din[12]) + Str$(HEX2 Din[13]) + Str$(HEX2 Din[14])
    CompareDateTime = "----------"
    SD_File_Name = "GLYPHIX":SD_File_Ext = "SCH"
    X=0
    SchCount = 0
    BitOK = 0
    Response = SD_Open_File
    If Response = 0 Then
        For Y = 0 To 12
            Din[Y] = SD_Read_Byte_From_File
        Next Y
        If Left$(Din,13) = "[GLYPHIX SCH]" Then
            '--- if we are still here, that means that we are in the SCH-file, data part ---
            Repeat
                '--- skip the first 2 numbers in the year-part !
                For Y = 0 To 1
                    Response = SD_Read_Byte_From_File    
                Next Y
                If Response < "9" Then  
                    '--- read date ---
                    For Y = 0 To 9
                        Response = SD_Read_Byte_From_File
                        CompareDateTime[Y] = Response
                    Next Y
                    '--- read itemdata (13 chars) ---
                    For Y = 0 To 12
                        Response = SD_Read_Byte_From_File
                        ItemData[Y]=Response
                    Next Y
                    Response = 0
                    ScheduleDEC = Val(ScheduleDateTime,Dec)
                    CompareDEC = Val(CompareDateTime,Dec)
                    '--- first, we need to find valid data (e.g. not yet passed) ---
                    If CompareDEC > ScheduleDEC Then
                        '--- if we request scheduler info, just return it, don't do anything else ---
                        If RequestType = 3 Then
                            Dout[0] = "W"
                            Dout[1] = "1"
                            '--- day ---
                            Dout[2] = CompareDateTime[4]
                            Dout[3] = CompareDateTime[5]                            
                            '--- month ---
                            Dout[4] = CompareDateTime[2]
                            Dout[5] = CompareDateTime[3]                            
                            '--- year ---
                            Dout[6] = CompareDateTime[0]
                            Dout[7] = CompareDateTime[1]
                            '--- hours ---
                            Dout[8] = CompareDateTime[6]
                            Dout[9] = CompareDateTime[7]
                            '--- minutes ---
                            Dout[10] = CompareDateTime[8]
                            Dout[11] = CompareDateTime[9]
                            Dout[12] = " "
                            Dout[13] = " "
                            Dout[14] = " "
                            Dout[15] = " "
                            GoSub SendData
                            X = 5
                            Return
                        EndIf
                        '--- if we are re-positioning, then skip until correct position ---
                        If SchPos > 0 Then
                            SchCount = SchCount + 1
                            If SchCount > SchPos Then
                                BitOK = 1
                            EndIf
                        Else
                            BitOK = 1
                        EndIf
                        '--- only do it when necessary
                        If BitOK = 1 Then    
                            Dout = CompareDateTime
                            Dout[0] = CompareDateTime[4]
                            Dout[1] = CompareDateTime[5]
                            Dout[2] = "/"
                            Dout[3] = CompareDateTime[2]
                            Dout[4] = CompareDateTime[3]
                            Dout[5] = "/"
                            Dout[6] = CompareDateTime[0]
                            Dout[7] = CompareDateTime[1]
                            Dout[8] = " "
                            Dout[9] = CompareDateTime[6]
                            Dout[10] = CompareDateTime[7]
                            Dout[11] = ":"
                            Dout[12] = CompareDateTime[8]
                            Dout[13] = CompareDateTime[9]
                            Dout[14] = " "
                            Dout[15] = " "
                            GoSub SendData
                            X = X + 1
                            '--- if info requested then, do this part ---
                            If RequestType = 2 Then
                                '--- send 5 lines of data !
                                If ItemData[0] = "A" Then
                                    Dout = "[ANIMATIE]      "
                                Else
                                    Dout = "[SPEELLIJST]    "
                                EndIf
                                GoSub SendData
                                Dout = Mid$(ItemData,2,8) +"        "
                                GoSub SendData
                                Dout = "                "
                                GoSub SendData
                                SD_File_Name = Mid$(ItemData,2,8)
                                SD_File_Ext = Mid$(ItemData,11,3)
                                Response = SD_Open_File 
                                If Response = 0 Then
                                    '--- skip header ---
                                    NbrChars = 13:GoSub ReadBytesFromFile
                                    '--- get frames/files count ---
                                    NbrChars = 5:GoSub ReadBytesFromFile
                                    If ItemData[0] = "P" Then
                                        Dout="Files:  " + Left$(Din,5) + "   "
                                    Else
                                        Dout="Frames: " + Left$(Din,5) + "   "                
                                    EndIf
                                    GoSub SendData
                                    '--- get extra info         ---
                                    NbrChars = 15:GoSub ReadBytesFromFile   '--- skip creation date/time ---
                                    NbrChars = 12:GoSub ReadBytesFromFile   '--- skip author             ---
                                    NbrChars = 13:GoSub ReadBytesFromFile    '--- get extra info          ---
                                    Dout = Left$(Din,13) + "   "
                                    GoSub SendData
                                Else
                                    '--- if scheduled data not found on SD/MMC-card ---
                                    Dout = "BESTAND NIET    "
                                    GoSub SendData
                                    Dout = "GEVONDEN !      "
                                    GoSub SendData
                                EndIf
                                '--- prevent further execution of this function ---    
                                X = 5
                            EndIf
                        EndIf
                    EndIf
                EndIf
            Until Response > "8" Or X = 5
        EndIf
    EndIf
    If X < 5 Then
        If RequestType = 3 Then
            '--- send back empty request data for scheduler ---
            Dout = "W0              "
            GoSub SendData
        Else
            '--- fill rest with empty data, to "complete" a list ---
            For Y = X To 4
                Dout = "----------------"
                GoSub SendData
            Next Y
        EndIf
    EndIf  
Return  
    


'Dout = Str$(HEX2 Din[12]) + "/" + Str$(HEX2 Din[11]) + "/" + Str$(HEX2 Din[10]) + " " + Str$(HEX2 Din[13]) + ":" + Str$(HEX2 Din[14]) + "  "
'GoSub SendData   
'GoSub SendData   
'GoSub SendData   
'GoSub SendData   
'GoSub SendData   
        


'-----------------------------------------------------------------------
'--- "jump" to the file with the given position                      ---
'-----------------------------------------------------------------------
PositionToFile:
    AX = (Din[2]*5)
    AX = AX + Din[3] - 1
    SD_Dir SD_First
    If SD_File_Ext != SelectExt Then
        Repeat
            Response = SD_Dir SD_Next
        Until SD_File_Ext = SelectExt
    EndIf
    
    If AX > 0 Then
        For AY = 1 To  AX
            Repeat
                Response = SD_Dir SD_Next
            Until SD_File_Ext = SelectExt
        Next AY
    EndIf
Return

'-----------------------------------------------------------------------
'--- read XX bytes from the file                                     ---
'-----------------------------------------------------------------------
ReadBytesFromFile:
    For X = 0 To NbrChars - 1
        Response = SD_Read_Byte_From_File
        Din[X] = Response
    Next X
Return

'-----------------------------------------------------------------------
'--- if ANI or LST, then return file-info                            ---
'-----------------------------------------------------------------------
ReturnFileInfo:
    If Response = 0 Then
        Dout = SD_File_Name + "." + SD_File_Ext + "    "
        GoSub SendData
        '--- read from file ---
        Response = SD_Open_File 
        NbrChars = 13:GoSub ReadBytesFromFile
        Dout = "[GLYPHIX " + SelectExt + "]"
        Dout = Left$(Dout,13)
        Din  = Left$(Din,13)
        If Dout = Din Then
            '--- frames or files ---
            NbrChars = 5:GoSub ReadBytesFromFile
            If SelectExt = "ANI" Then
                Dout="Frames: " + Left$(Din,5) + "   "
            Else
                Dout="Files:  " + Left$(Din,5) + "   "                
            EndIf
            GoSub SendData
            '--- date ---
            NbrChars = 10:GoSub ReadBytesFromFile
            Dout = $F + "  " + Left$(Din,10) + "   "
            GoSub SendData
            '--- time ---       
            NbrChars = 5:GoSub ReadBytesFromFile
            Dout = "        " + Left$(Din,5) + "   "
            GoSub SendData
            '--- author ---
            NbrChars = 12:GoSub ReadBytesFromFile
            Dout = $E + Left$(Din,12) + "   "
            GoSub SendData
            '---reference ---
            NbrChars = 13:GoSub ReadBytesFromFile
            Dout = Left$(Din,13) + "   "
            GoSub SendData                
        Else 
            Dout = "Dit is geen     "
            GoSub SendData
            Dout = "geldige         "
            GoSub SendData
            Dout = "GLYPHIX         "
            GoSub SendData
            If SelectExt = "ANI" Then
                Dout = "animatie !      "
            Else
                Dout = "speellijst !    "            
            EndIf
            GoSub SendData
            Dout = "                "
            GoSub SendData
        EndIf
    Else
        Dout = "FOUT !          "
        GoSub SendData
        Dout = "Probleem met    "
        GoSub SendData
        Dout = "MMC/SD kaart!   " 
        GoSub SendData
        Dout = "                "
        GoSub SendData
        Dout = SD_File_Name + "." + SD_File_Ext + "    "
        GoSub SendData
        Dout = "                "
        GoSub SendData
    EndIf        
Return

'-----------------------------------------------------------------------
'--- return 5 lines with filenames (otherwise, also send empty data  ---
'-----------------------------------------------------------------------
ReturnFileNames:
    X=0
    Response = SD_Dir SD_First
    
    If SD_File_Ext != SelectExt Then
        Repeat
            Response = SD_Dir SD_Next
        Until SD_File_Ext = SelectExt Or Response > 0
    EndIf
    
    '--- move in filelist to given position ---
    If Din[2] > 0 Then
        AY = (Din[2] * 5) - 1
        For AX = 1 To AY 
            Repeat
                Response = SD_Dir SD_Next
            Until SD_File_Ext = SelectExt Or Response > 0
        Next X
    Else
        If SD_File_Ext = SelectExt Then
            X=1
            Dout = SD_File_Name + "." + SD_File_Ext +"    "
            GoSub SendData        
        EndIf
    EndIf
    Repeat
        Repeat 
            Response = SD_Dir SD_Next
        Until SD_File_Ext = SelectExt Or Response > 0
        If Response = 0 Then 
            X = X + 1
            Dout = Left$(SD_File_Name,8) + "." + SD_File_Ext +"    "
            GoSub SendData
        EndIf
    Until Response > 0 Or X = 5
    '--- if not 4 filenames are present, then return empty values ---
    If X < 5 Then
        For Y = X To 4
            Dout = "------------    "
            GoSub SendData
        Next Y
    EndIf
Return

'-----------------------------------------------------------------------
'--- receive data                                                    ---
'-----------------------------------------------------------------------
ReceiveData:
    'Disable Debug
    Repeat 
        High DOutPin
    Until DInPin = 0
    
    For xxx = 0 To 15
        For zzz = 0 To 7
            Repeat
            Until DInClk = 1
            If DInPin = 1 Then
                SetBit yyy,zzz 
            Else
                ClearBit yyy,zzz
            EndIf
            Repeat
                Low DOutPin
            Until DInClk = 0
            High DOutPin
        Next zzz
        Din[xxx] = yyy
    Next xxx 
    Low DOutPin
    DelayUS 5
    'Enable Debug
Return

'-----------------------------------------------------------------------
'--- send data                                                       ---
'-----------------------------------------------------------------------
SendData:
    'Disable Debug
    Repeat
        High DOutPin    
    Until DInPin = 1
    Low DOutPin
    
    For xxx = 0 To 15
        For zzz = 0 To 7
            yyy = Dout[xxx]
            DOutPin = GetBit yyy,zzz
            Repeat 
                High DOutClk
            Until DInPin = 0
            Repeat
                Low DOutClk
            Until DInPin = 1
        Next zzz
    Next xxx
    Low DOutPin
    DelayUS 5
    'Enable Debug
Return

'-------------------------------------------------------------------------------
'--- write actual data to LED matrix                                         ---
'-------------------------------------------------------------------------------
WriteData:
    Low DataLoad
        WriteLoop = 8
        Repeat
            SHOut DataIn,DataClk,msbfirst,[IdNr]
            SHOut DataIn,DataClk,msbfirst,[Value[WriteLoop]]
            WriteLoop = WriteLoop - 1
        Until WriteLoop < 1            
    High DataLoad
    DelayUS 1
    Low DataLoad
Return

'-------------------------------------------------------------------------------
'--- set all values the same, so we can update the whole LED matrix          ---
'-------------------------------------------------------------------------------
SetNext127:
    a = 0
    Repeat
        Inc a
        Value[a] = Value[1]    
    Until a = 128
Return

'-------------------------------------------------------------------------------
'--- set brightness of LED matrix                                            ---
'-------------------------------------------------------------------------------
SetMatrixBrightNess:
    IdNr=$0A:Value[1]=$0F:GoSub SetNext127:GoSub WriteData
Return


'-------------------------------------------------------------------------------

'-------------------------------------------------------------------------------
'--- do actual animation on LED matrix                                       ---
'-------------------------------------------------------------------------------
DoAnimation:
        ticker = 0
        a=0
        Repeat
            Inc a
            IdNr = 0
            Repeat
                Inc IdNr
                c=0
                Repeat
                    Inc c
                    Value[c] = LRead CorkScrew + ticker
                    Inc ticker
                Until c = 8
                GoSub WriteData
            Until IdNr = 8
            DelayMS 10
        Until a = 14
Return

CorkScrew:
LData As Byte 128,64,32,16,8,4,2,1,64,32,32,16,8,4,4,2,32,16,16,16,8,8,8,4,16,16,16,16,8,8,8,8,8,8,8,8,16,16,16,16,4,8,8,8,16,16,16,32,2,4,4,8,16,32,32,64,1,2,4,8,16,32,64,128
LData As Byte 64,32,16,8,4,2,1,0,32,32,16,8,4,4,2,1,16,16,16,8,8,8,4,2,16,16,16,8,8,8,8,12,8,8,8,16,16,16,16,48,8,8,8,16,16,16,32,64,4,4,8,16,32,32,64,128,2,4,8,16,32,64,128,0
LData As Byte 32,16,8,4,2,1,0,0,32,16,8,4,4,2,1,0,16,16,8,8,8,4,2,3,16,16,8,8,8,8,12,12,8,8,16,16,16,16,48,48,8,8,16,16,16,32,64,192,4,8,16,32,32,64,128,0,4,8,16,32,64,128,0,0
LData As Byte 16,8,4,2,1,0,0,0,16,8,4,4,2,1,0,0,16,8,8,8,4,2,3,0,16,8,8,8,8,12,12,15,8,16,16,16,16,48,48,240,8,16,16,16,32,64,192,0,8,16,32,32,64,128,0,0,8,16,32,64,128,0,0,0
LData As Byte 8,4,2,1,0,0,0,0,8,4,4,2,1,0,0,0,8,8,8,4,2,3,0,0,8,8,8,8,12,12,15,240,16,16,16,16,48,48,240,15,16,16,16,32,64,192,0,0,16,32,32,64,128,0,0,0,16,32,64,128,0,0,0,0
LData As Byte 4,2,1,0,0,0,0,0,4,4,2,1,0,0,0,0,8,8,4,2,3,0,0,192,8,8,8,12,12,15,240,48,16,16,16,48,48,240,15,12,16,16,32,64,192,0,0,3,32,32,64,128,0,0,0,0,32,64,128,0,0,0,0,0
LData As Byte 2,1,0,0,0,0,0,0,4,2,1,0,0,0,0,128,8,4,2,3,0,0,192,64,8,8,12,12,15,240,48,48,16,16,48,48,240,15,12,12,16,32,64,192,0,0,3,2,32,64,128,0,0,0,0,1,64,128,0,0,0,0,0,0
LData As Byte 1,0,0,0,0,0,0,128,2,1,0,0,0,0,128,64,4,2,3,0,0,192,64,32,8,12,12,15,240,48,48,16,16,48,48,240,15,12,12,8,32,64,192,0,0,3,2,4,64,128,0,0,0,0,1,2,128,0,0,0,0,0,0,1
LData As Byte 0,0,0,0,0,0,128,64,1,0,0,0,0,128,64,32,2,3,0,0,192,64,32,16,12,12,15,240,48,48,16,16,48,48,240,15,12,12,8,8,64,192,0,0,3,2,4,8,128,0,0,0,0,1,2,4,0,0,0,0,0,0,1,2
LData As Byte 0,0,0,0,0,128,64,32,0,0,0,0,128,64,32,32,3,0,0,192,64,32,16,16,12,15,240,48,48,16,16,16,48,240,15,12,12,8,8,8,192,0,0,3,2,4,8,8,0,0,0,0,1,2,4,4,0,0,0,0,0,1,2,4
LData As Byte 0,0,0,0,128,64,32,16,0,0,0,128,64,32,32,16,0,0,192,64,32,16,16,16,15,240,48,48,16,16,16,16,240,15,12,12,8,8,8,8,0,0,3,2,4,8,8,8,0,0,0,1,2,4,4,8,0,0,0,0,1,2,4,8
LData As Byte 0,0,0,128,64,32,16,8,0,0,128,64,32,32,16,8,0,192,64,32,16,16,16,8,240,48,48,16,16,16,16,8,15,12,12,8,8,8,8,16,0,3,2,4,8,8,8,16,0,0,1,2,4,4,8,16,0,0,0,1,2,4,8,16
LData As Byte 0,0,128,64,32,16,8,4,0,128,64,32,32,16,8,4,192,64,32,16,16,16,8,8,48,48,16,16,16,16,8,8,12,12,8,8,8,8,16,16,3,2,4,8,8,8,16,16,0,1,2,4,4,8,16,32,0,0,1,2,4,8,16,32
LData As Byte 0,128,64,32,16,8,4,2,128,64,32,32,16,8,4,4,64,32,16,16,16,8,8,8,48,16,16,16,16,8,8,8,12,8,8,8,8,16,16,16,2,4,8,8,8,16,16,16,1,2,4,4,8,16,32,32,0,1,2,4,8,16,32,64



