Attribute VB_Name = "ModDateTimeManipulation"
'---------------------------------------------------------------------------
' Description        : Date Functions Library for use in VB projects
'
' Originator         : Wauters Kris
' Date Started       : 26 july 2002
' Date Last Modified : 26 july 2002
' Last Modified by   : Wauters Kris
'
' Functions included in this lib:
' -------------------------------
' YMDOrder() As String
' GiveCurrentDateInAppFormat() As String
' GiveCurrentDateInSQLFormat() As String
' GiveCurrentDateAndTimeInAppFormat() As String
' GiveCurrentDateAndTimeInSQLFormat() As String
' DateFromSQLToAppFormat(Date) As String
' DateFromAppToSqlFormat(Date) As String
' DateAndTimeFromAppToSQLFormat(DateAndTime) As String
' DateAndTimeFromSQLToAppFormat(DateAndTime) As String
'---------------------------------------------------------------------------
Public Function YMDOrder() As String
  '--- declare variables ---
    Dim IntI As Integer
    Dim Intm_year As Integer
    Dim Intm_month As Integer
    Dim Intm_day As Integer
    Dim Intm_1st As Integer
    Dim Intm_2nd As Integer
    Dim Intm_3rd As Integer
    Dim Datem_Date As Date
    Dim Strm_Parse As String
    Dim Strm_sDate As String
    Dim Strm_Order As String
    Dim Intsep1 As Integer
    Dim Intsep2 As Integer
    
    Intm_year = 1
    Intm_month = 2
    Intm_day = 3
    Datem_Date = DateSerial(Intm_year, Intm_month, Intm_day)
    Strm_sDate = Datem_Date
    IntI = 1

    Do
        Strm_Parse = Mid$(Strm_sDate, IntI, 1)
        Intsep1 = IntI
        IntI = IntI + 1
    Loop While IsNumeric(Strm_Parse)

    Do
        Strm_Parse = Mid$(Strm_sDate, IntI, 1)
        Intsep2 = IntI
        IntI = IntI + 1
    Loop While IsNumeric(Strm_Parse)
    
    Intm_1st = Right(Left(Strm_sDate, Intsep1 - 1), 1)
    Intm_2nd = Right(Mid(Strm_sDate, Intsep1 + 1, Intsep2 - (Intsep1 + 1)), 1)
    Intm_3rd = Right(Right(Strm_sDate, Len(Strm_sDate) - Intsep2), 1)
    Strm_Order = CStr(Intm_1st) & CStr(Intm_2nd) & CStr(Intm_3rd)
    Mid(Strm_Order, InStr(1, Strm_Order, "1"), 1) = "y"
    Mid(Strm_Order, InStr(1, Strm_Order, "2"), 1) = "m"
    Mid(Strm_Order, InStr(1, Strm_Order, "3"), 1) = "d"
    YMDOrder = Strm_Order

End Function
'---------------------------------------------------------------------
' convert time in localized time format to databaseformat
'
' Parameters:
' -----------
'             time in localized time format as string
'
' Returns time in format HHMM
'---------------------------------------------------------------------
Public Function TimeFromAppToSQLFormat(StrPassedTime As String) As String
  '--- declare variables ---
  Dim StrHours As String
  Dim StrMinutes As String
  
  StrHours = Mid$(StrPassedTime, 1, 2)
  StrMinutes = Mid$(StrPassedTime, 4, 2)
  
  TimeFromAppToSQLFormat = StrHours & StrMinutes
End Function
'---------------------------------------------------------------------
' convert time in databaseformat to localized time
'
' Parameters:
' -----------
'             time in databaseformat as string
'
' Returns time in format like defined in localised settings as string
'---------------------------------------------------------------------
Public Function TimeFromSQLToAppFormat(StrPassedTime As String) As String
  '--- declare variables ---
  Dim StrHours As String
  Dim StrMinutes As String
  
  StrHours = Mid$(StrPassedTime, 1, 2)
  StrMinutes = Mid$(StrPassedTime, 3, 2)
  
  TimeFromSQLToAppFormat = StrHours & ":" & StrMinutes
End Function

  '--- declare variables ---

'---------------------------------------------------------------------
' convert date in databaseformat to localized date
'
' Parameters:
' -----------
'             date in databaseformat as string
'
' Returns date in format like defined in localised settings as string
'---------------------------------------------------------------------
Public Function DateFromSQLToAppFormat(StrPassedDate As String) As String
  '--- declare variables ---
  Dim StrDateOrder As String
  Dim StrDay As String
  Dim StrMonth As String
  Dim StrYear As String
  
  StrDateOrder = YMDOrder

  StrYear = Left$(StrPassedDate, 4)
  StrMonth = Mid$(StrPassedDate, 5, 2)
  StrDay = Right$(StrPassedDate, 2)
    
  Select Case YMDOrder
    Case "ymd"
      DateFromSQLToAppFormat = StrYear & "/" & StrMonth & "/" & StrDay
    Case "ydm"
      DateFromSQLToAppFormat = StrYear & "/" & StrDay & "/" & StrMonth
    Case "dym"
      DateFromSQLToAppFormat = StrDay & "/" & StrYear & "/" & StrMonth
    Case "dmy"
      DateFromSQLToAppFormat = StrDay & "/" & StrMonth & "/" & StrYear
    Case "mdy"
      DateFromSQLToAppFormat = StrMonth & "/" & StrDay & "/" & StrYear
    Case "myd"
      DateFromSQLToAppFormat = StrMonth & "/" & StrYear & "/" & StrDay
  End Select
  
End Function
Public Function ReturnFormatStringDate() As String
  StrDateOrder = YMDOrder

  Select Case YMDOrder
    Case "ymd"
      ReturnFormatStringDate = "yyyy/MM/dd"
    Case "ydm"
      ReturnFormatStringDate = "yyyy/dd/MM"
    Case "dym"
      ReturnFormatStringDate = "dd/yyyy/MM"
    Case "dmy"
      ReturnFormatStringDate = "dd/MM/yyyy"
    Case "mdy"
      ReturnFormatStringDate = "MM/dd/yyyy"
    Case "myd"
      ReturnFormatStringDate = "MM/yyyy/dd"
  End Select
End Function
'---------------------------------------------------------------------
' convert date and time in databaseformat to localized date
'
' Parameters:
' -----------
'             date in databaseformat as string
'
' Returns date in format like defined in localised settings as string
'---------------------------------------------------------------------
Public Function DateAndTimeFromSQLToAppFormat(StrPassedDateAndTime As String) As String
  '--- declare variables ---
  Dim StrDateOrder As String
  Dim StrDay As String
  Dim StrMonth As String
  Dim StrYear As String
  Dim StrHours As String
  Dim StrMinutes As String
  
  StrDateOrder = YMDOrder

  StrYear = Mid$(StrPassedDateAndTime, 1, 4)
  StrMonth = Mid$(StrPassedDateAndTime, 5, 2)
  StrDay = Mid$(StrPassedDateAndTime, 7, 2)
  StrHours = Mid$(StrPassedDateAndTime, 9, 2)
  StrMinutes = Mid$(StrPassedDateAndTime, 11, 2)
    
  Select Case YMDOrder
    Case "ymd"
      DateAndTimeFromSQLToAppFormat = StrYear & "/" & StrMonth & "/" & StrDay
    Case "ydm"
      DateAndTimeFromSQLToAppFormat = StrYear & "/" & StrDay & "/" & StrMonth
    Case "dym"
      DateAndTimeFromSQLToAppFormat = StrDay & "/" & StrYear & "/" & StrMonth
    Case "dmy"
      DateAndTimeFromSQLToAppFormat = StrDay & "/" & StrMonth & "/" & StrYear
    Case "mdy"
      DateAndTimeFromSQLToAppFormat = StrMonth & "/" & StrDay & "/" & StrYear
    Case "myd"
      DateAndTimeFromSQLToAppFormat = StrMonth & "/" & StrYear & "/" & StrDay
  End Select
  
  DateAndTimeFromSQLToAppFormat = DateAndTimeFromSQLToAppFormat & " " & StrHours & ":" & StrMinutes
End Function
'---------------------------------------------------------------------
' convert current date to date in databaseformat
'
' Parameters:
' -----------
'             NONE
'
' Returns date in databaseformat as string
'---------------------------------------------------------------------
Public Function GiveCurrentDateInSQLFormat() As String
  Dim StrYear As Integer
  Dim StrMonth As Integer
  Dim StrDay As Integer
  
  StrYear = DatePart("yyyy", Now)
  StrMonth = DatePart("m", Now)
  StrDay = DatePart("d", Now)
  
  GiveCurrentDateInSQLFormat = Right("0000" & Trim(Str(StrYear)), 4) & Right("00" & Trim(Str(StrMonth)), 2) & Right("00" & Trim(Str(StrDay)), 2)
End Function
'---------------------------------------------------------------------
' convert current date to date format defined in localised settings
'
' Parameters:
' -----------
'             Localized date as string
'
' Returns date in localised format as string
'---------------------------------------------------------------------
Public Function GiveCurrentDateInAppFormat() As String
  GiveCurrentDateInAppFormat = DateFromSQLToAppFormat(GiveCurrentDateInSQLFormat)
End Function

'---------------------------------------------------------------------
' convert current date and time to date and time format defined in localised settings
'
' Parameters:
' -----------
'             Localized date as string
'
' Returns date and time in localised format as string
'---------------------------------------------------------------------
Public Function GiveCurrentDateAndTimeInAppFormat() As String
  GiveCurrentDateAndTimeInAppFormat = DateFromSQLToAppFormat(GiveCurrentDateInSQLFormat) & " " & Mid$(Time$, 1, 5)
End Function
'---------------------------------------------------------------------
' convert current date and time to date and time in databaseformat
'
' Parameters:
' -----------
'             NONE
'
' Returns date and time in databaseformat as string
'---------------------------------------------------------------------
Public Function GiveCurrentDateAndTimeInSQLFormat() As String
  Dim StrYear As Integer
  Dim StrMonth As Integer
  Dim StrDay As Integer
  
  StrYear = DatePart("yyyy", Now)
  StrMonth = DatePart("m", Now)
  StrDay = DatePart("d", Now)
  
  GiveCurrentDateAndTimeInSQLFormat = Right("0000" & Trim(Str(StrYear)), 4) & Right("00" & Trim(Str(StrMonth)), 2) & Right("00" & Trim(Str(StrDay)), 2) & Mid$(Time$, 1, 2) & Mid$(Time$, 4, 2)
End Function


'---------------------------------------------------------------------
' convert date from format defined in local settings to databaseformat
'
' Parameters:
' -----------
'             Localized date as string
'
' Returns date in databaseformat as string
'---------------------------------------------------------------------
Public Function DateFromAppToSqlFormat(StrPassedDate As String) As String
  Dim StrYear As String
  Dim StrMonth As String
  Dim StrDay As String
  Dim StrDateOrder As String
  
  Select Case YMDOrder
    Case "ymd"
      StrYear = Left$(StrPassedDate, 4)
      StrMonth = Mid$(StrPassedDate, 6, 2)
      StrDay = Right$(StrPassedDate, 2)
    Case "ydm"
      StrYear = Left$(StrPassedDate, 4)
      StrDay = Mid$(StrPassedDate, 6, 2)
      StrMonth = Right$(StrPassedDate, 2)
    Case "dym"
      StrDay = Left$(StrPassedDate, 2)
      StrYear = Mid$(StrPassedDate, 4, 4)
      StrMonth = Right$(StrPassedDate, 2)
    Case "dmy"
      StrDay = Left$(StrPassedDate, 2)
      StrMonth = Mid$(StrPassedDate, 4, 2)
      StrYear = Right$(StrPassedDate, 4)
    Case "mdy"
      StrMonth = Left$(StrPassedDate, 2)
      StrDay = Mid$(StrPassedDate, 4, 2)
      StrYear = Right$(StrPassedDate, 4)
    Case "myd"
      StrMonth = Left$(StrPassedDate, 2)
      StrYear = Mid$(StrPassedDate, 4, 4)
      StrDay = Right$(StrPassedDate, 2)
  End Select

  DateFromAppToSqlFormat = StrYear & StrMonth & StrDay
End Function
'---------------------------------------------------------------------
' convert date from format defined in local settings to databaseformat
'
' Parameters:
' -----------
'             Localized date as string
'
' Returns date in databaseformat as string
'---------------------------------------------------------------------
Public Function DateAndTimeFromAppToSQLFormat(StrPassedDateAndTime As String) As String
  '--- declare variables ---
  Dim StrYear As String
  Dim StrMonth As String
  Dim StrDay As String
  Dim StrHours As String
  Dim StrMinutes As String
  Dim StrDateOrder As String
  
  Select Case YMDOrder
    Case "ymd"
      StrYear = Mid$(StrPassedDateAndTime, 1, 4)
      StrMonth = Mid$(StrPassedDateAndTime, 6, 2)
      StrDay = Mid$(StrPassedDateAndTime, 9, 2)
    Case "ydm"
      StrYear = Mid$(StrPassedDateAndTime, 1, 4)
      StrDay = Mid$(StrPassedDateAndTime, 6, 2)
      StrMonth = Mid$(StrPassedDateAndTime, 9, 2)
    Case "dym"
      StrDay = Mid$(StrPassedDateAndTime, 1, 2)
      StrYear = Mid$(StrPassedDateAndTime, 4, 4)
      StrMonth = Mid$(StrPassedDateAndTime, 9, 2)
    Case "dmy"
      StrDay = Mid$(StrPassedDateAndTime, 1, 2)
      StrMonth = Mid$(StrPassedDateAndTime, 4, 2)
      StrYear = Mid$(StrPassedDateAndTime, 7, 4)
    Case "mdy"
      StrMonth = Mid$(StrPassedDateAndTime, 1, 2)
      StrDay = Mid$(StrPassedDateAndTime, 4, 2)
      StrYear = Mid$(StrPassedDateAndTime, 7, 4)
    Case "myd"
      StrMonth = Mid$(StrPassedDateAndTime, 1, 2)
      StrYear = Mid$(StrPassedDateAndTime, 4, 4)
      StrDay = Mid$(StrPassedDateAndTime, 9, 2)
  End Select

  StrHours = Mid$(StrPassedDateAndTime, 12, 2)
  StrMinutes = Mid$(StrPassedDateAndTime, 15, 2)
  
  DateAndTimeFromAppToSQLFormat = StrYear & StrMonth & StrDay & StrHours & StrMinutes
End Function


